package ovh.herisson.Clyde.Services;

import org.springframework.stereotype.Service;
import ovh.herisson.Clyde.Repositories.CurriculumCourseRepository;
import ovh.herisson.Clyde.Tables.Course;
import ovh.herisson.Clyde.Tables.Curriculum;
import ovh.herisson.Clyde.Tables.CurriculumCourse;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

@Service
public class CurriculumCourseService {

    private final CurriculumCourseRepository curriculumCourseRepo;


    public CurriculumCourseService(CurriculumCourseRepository curriculumCourseRepository) {
        this.curriculumCourseRepo = curriculumCourseRepository;
    }

    public void save(CurriculumCourse curriculumCourse){
        curriculumCourseRepo.save(curriculumCourse);
    }


    public Map<String, Object> getDepthCurriculum(Curriculum curriculum){

        if (curriculum == null)
            return null;

        HashMap<String ,Object> toReturn = new HashMap<>();
        ArrayList<Course> courses = new ArrayList<>();
        for (Course c: curriculumCourseRepo.findCoursesByCurriculum(curriculum)){
            courses.add(c);
        }
        toReturn.put("courses",courses);
        toReturn.put("curriculumId", curriculum.getCurriculumId());
        toReturn.put("year", curriculum.getYear());
        toReturn.put("option", curriculum.getOption());


        return  toReturn;
    }

    public Iterable<Map<String, Object>> getAllDepthCurriculum(){

        ArrayList<Map<String,Object>> toReturn = new ArrayList<>();

        for (Curriculum curriculum : curriculumCourseRepo.findDistinctCurriculums()){
            toReturn.add(getDepthCurriculum(curriculum));
        }
        return toReturn;
    }
}
